namespace FKGees.DocsDefinitions.Decrets;

public class KpKaucjaZaOpakowania : IDecretsDefinition
{
    public int DocType => 51;
    public string Type => nameof(KpKaucjaZaOpakowania);
    public List<Definition> Definitions { get; } = [
        new Definition("100-1-24", "WN", "[sbr]"), 
        new Definition("139-1-24", "MA", "[sbr]")
    ];

    public Task<List<DecretsResult>> Process(IReadOnlyList<Dok> documents)
    {
        var result = new List<DecretsResult>();

        var toProcess = documents
            .Where(x => x.TypDok == DocType
                        && x.NrDok.StartsWith("KP")
                        && x.Tekst1() == Constants.KpTekstyDod[nameof(KpKaucjaZaOpakowania)]);

        foreach (var dok in toProcess)
        {
            Definitions.ForEach(d =>
            {
                var item = dok.DecretKontr();
                item.Data = dok.DataPom;
                item.DataWplywu = dok.Data;
                item.Nr = dok.NrDok;
                item.Opis = dok.TekstZaCo();
                item.StronaKonta = d.AccountSide;
                item.KontoFk = d.Account;
                item.Kwota = Math.Abs(dok.Zaplacono).AsString();

                result.Add(item);
            });
        }

        return Task.FromResult(result);
    }
}